
#include "project.h"
#include "stdio.h"


//void Dma_S_Tx_Configuration(void);
void Dma_S_Rx_Configuration(void);


/* DMA Configuration for DMA_TX_S */
#define DMA_TX_S_BYTES_PER_BURST       (1u)
#define DMA_TX_S_REQUEST_PER_BURST     (1u)
#define DMA_TX_S_SRC_BASE              (CYDEV_SRAM_BASE)
#define DMA_TX_S_DST_BASE              (CYDEV_PERIPH_BASE)

/* DMA Configuration for DMA_RX_S */
#define DMA_RX_S_BYTES_PER_BURST       (1u)
#define DMA_RX_S_REQUEST_PER_BURST     (1u)
#define DMA_RX_S_SRC_BASE              (CYDEV_PERIPH_BASE)
#define DMA_RX_S_DST_BASE              (CYDEV_SRAM_BASE)

#define TRANSMIT_BUFFER_SIZE  20

char DataArray[TRANSMIT_BUFFER_SIZE];
char B_Zahler[TRANSMIT_BUFFER_SIZE];

/* Variable declarations for DMA_Tx_S */
uint8 S_TxChannel;
uint8 S_TxTD[2u];

/* Variable declarations for DMA_Rx_S */
uint8 S_RxChannel;
uint8 S_RxTD[2u];

/* Data to be transmitted by Tx */
uint8 s_txBuffer [8u];
uint8 s_rxBuffer[8u];
uint8 B_Counter = 0;
uint8 ISR2Counter =0;


/* Interrupt */
 int flag=0;

CY_ISR(WakeupIsr)
{
    flag=1;
    SPIS_RX_STATUS_MASK_REG=1;
    B_Counter++;
//    DMA_RX_S_DmaRelease();
}


CY_ISR(WakeupIsr2)
{
    ISR2Counter++;
}

int main(void)
{    
    uint8 i = 0u;
    

    CyGlobalIntEnable; 
    isr_1_StartEx(WakeupIsr);
    isr_2_StartEx(WakeupIsr2);
        
    SPIS_Start();
    UART_1_Start();
    UART_1_PutString("\n\n#####################################\r\nKonfiguriere SPI Übertragung......\r\n#####################################\r\n\n");
    SPIS_Start();
    
//    Dma_S_Tx_Configuration();
    Dma_S_Rx_Configuration();
//    CyDmaChEnable(S_TxChannel, 1u);
    CyDmaChEnable(S_RxChannel, 1u);
    

     while(1u)
    {
     SPIS_EnableInt();

         UART_1_PutString("Byte received!\r\n"); 
         sprintf(B_Zahler,"%d. ",ISR2Counter);
         UART_1_PutString(B_Zahler);  
         CyDelay(1000);

        if(flag)
        {  
//            CyDmaChDisable(S_RxChannel);
              flag=0;
            
//            SPIS_Start();             /*another Try*/
//            Dma_S_Tx_Configuration();
//            Dma_S_Rx_Configuration();
//            CyDmaChEnable(S_TxChannel, 1u);
//            CyDmaChEnable(S_RxChannel, 0u);
    
    
//             sprintf(B_Zahler,"%d. ",B_Counter);
//             UART_1_PutString(B_Zahler);  
//             UART_1_PutString("Byte empfangen!\r\n"); 
            
             UART_1_PutString("\nSlave Rx data:   "); 
             for(i=0u; i<1; i++) 
             {
             sprintf(DataArray, " %x ",s_rxBuffer[i]);
             UART_1_PutString(DataArray);
             }
             UART_1_PutString("\r\n____________________________________________\r\n\n");  

//            SPIS_RX_STATUS_MASK_REG=0;
//            flag=0;
//            CyDelay(500);
        }
    } 
}
    
/*****************************/
//        if(B_Counter==5)
//          {
//           B_Counter=0;
//           UART_1_PutString("\nAll 5 Rx data:   "); 
//           for(i=0u; i<5; i++) 
//               {
//               sprintf(DataArray, " %x ",s_rxBuffer[i]);
//               UART_1_PutString(DataArray);
//               }
//           UART_1_PutString("\r\n\n"); 
//           i=0;
//          }
/*******************************/



/**************************************************************************/
void Dma_S_Tx_Configuration()
{
    /* Init DMA, 1 byte bursts, each burst requires a request */ 
    S_TxChannel = DMA_TX_S_DmaInitialize(DMA_TX_S_BYTES_PER_BURST, DMA_TX_S_REQUEST_PER_BURST, 
                                        HI16(DMA_TX_S_SRC_BASE), HI16(DMA_TX_S_DST_BASE));

    S_TxTD[0u] = CyDmaTdAllocate();
    S_TxTD[1u] = CyDmaTdAllocate();

    /* Configure this Td chain as follows:
    *  - The TD is looping on itself
    *  - Increment the source address, but not the destination address   
    */
    CyDmaTdSetConfiguration(S_TxTD[0u], 1, DMA_DISABLE_TD, TD_TERMOUT1_EN|TD_INC_SRC_ADR);
    CyDmaTdSetConfiguration(S_TxTD[1u], 1, S_TxTD[1u], 0u);
    
    /* From the memory to the SPIS */
    
    CyDmaTdSetAddress(S_TxTD[0u], LO16((uint32)s_txBuffer), LO16((uint32)SPIS_BSPIS_sR8_Dp_u0__F0_REG));
    CyDmaTdSetAddress(S_TxTD[1u], LO16((uint32)s_txBuffer), LO16((uint32)s_txBuffer));
    
    
    /* Associate the TD with the channel */
    CyDmaChSetInitialTd(S_TxChannel, S_TxTD[0u]);
}    


/****************************************************************************************/
void Dma_S_Rx_Configuration()
{ 
    /* Init DMA, 1 byte bursts, each burst requires a request */ 
    S_RxChannel = DMA_RX_S_DmaInitialize(DMA_RX_S_BYTES_PER_BURST, DMA_RX_S_REQUEST_PER_BURST,
                                     HI16(DMA_RX_S_SRC_BASE), HI16(DMA_RX_S_DST_BASE));

    S_RxTD[0u] = CyDmaTdAllocate(); /*Transaction Describtor TD*/
    S_RxTD[1u] = CyDmaTdAllocate();
    /* Configure this Td as follows:
    *  - The TD is looping on itself
    *  - Increment the destination address, but not the source address
    */
    CyDmaTdSetConfiguration(S_RxTD[0u], 1, 1 , TD_TERMOUT0_EN|TD_INC_DST_ADR);
    CyDmaTdSetConfiguration(S_RxTD[1u], 1, S_RxTD[1u], 0);

    /* From the SPIM to the memory */
    CyDmaTdSetAddress(S_RxTD[0u], LO16((uint32)SPIS_RXDATA_PTR), LO16((uint32)s_rxBuffer));/*(TD, LO16SourceAdrss, LO16 Dest.Adrss )*/
    CyDmaTdSetAddress(S_RxTD[1u], LO16((uint32)s_rxBuffer), LO16((uint32)s_rxBuffer));

    /* Associate the TD with the channel */
    CyDmaChSetInitialTd(S_RxChannel, S_RxTD[0u]);
    
//                CyDmaChEnable(S_RxChannel, 1u);
}
   

/* [] END OF FILE */
